///home/berryj/link/bin/genMethods "-g" "-t" "Sequence<Edge*>" "-h" "List" "-I" "LINK/graph/Edge.h" "-I" "LINK/basic/Sequence.h" "-I" "LINK/basic/List.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Edge.h>

#include <LINK/basic/Sequence.h>

#include <LINK/basic/List.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Sequence<Edge*> _Sequence_Edge__;
typedef List<Sequence<Edge*> > _List_Sequence_Edge___;
static List<Sequence<Edge*> > s__List_Sequence_Edge___;

#define _List_Sequence_Edge___DATA(x) ((List<Sequence<Edge*> >*) (EXTDATA(x)))
#define _List_Sequence_Edge___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Sequence<Edge*> > >::type))
#define _List_Sequence_Edge___ISNT_DATA(x) (!_List_Sequence_Edge___IS_DATA(x))

#define _List_Sequence_Edge___CXX_DATA(x) (*(List<Sequence<Edge*> >*) (EXTDATA(VAL(x))))
#define _List_Sequence_Edge___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Sequence<Edge*> > >::type))
#define _List_Sequence_Edge___CXX_ISNT_DATA(x) (!_List_Sequence_Edge___CXX_IS_DATA(x))


PRIMITIVE STk_init__List_Sequence_Edge___()
{
	Wrapper<_List_Sequence_Edge___>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_Sequence_Edge___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Sequence_Edge__>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Sequence_Edge__>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Sequence_Edge__>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_Sequence_Edge___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_Sequence_Edge___Methods(void);

PRIMITIVE STk_init_methods__List_Sequence_Edge___()
{
	STk_add_new_cpp_primitive("List-Sequence-Edge-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Edge__>::makeLinkList);
	STk_add_new_cpp_primitive("List-Sequence-Edge?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Edge__>::linkListP);
	STk_add_new_cpp_primitive("list->List-Sequence-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Edge__>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-Sequence-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Edge__>::linkList2STkList);
	genExtra_List_Sequence_Edge___Methods();
	return UNDEFINED;
}
